/*
 * A.cpp
 *
 *  Created on: 05.12.2018
 *      Author: Wolfgang Knauf
 */

#include <iostream>       // std::cout
#include <thread>         // std::thread

#include "A.h"
#include "C.h"

using namespace std;

A::A() {

}

A::~A() {
}

int A::f(int x)
{
	C* c = new C(x);

	//Aufruf stammt von https://stackoverflow.com/questions/25043098/c11-threads-no-matching-function-call
	//Diese Seite (http://www.cplusplus.com/reference/thread/thread/thread/) gibt eine andere Syntax an,
	//aber das compiliert nicht.
	std::thread th (&C::g, c, 11, this);

	//"detach" muss sein, sonst Fehler: "This application has requested the Runtime to terminate it in an unusual way."
	th.detach();

	this->waitUntilNotified();

	return z;
}

void A::waitUntilNotified()
{
	do
	{
		//std::cout << "Waiting..." << std::endl;

		//50 Millisekunden warten...
		std::this_thread::sleep_for (50ms);
	}
	while (notified == false);
}

void A::notify(int z1)
{
	//std::cout << "NOTIFY" << std::endl;

	this->z = z1;
	this->notified = true;
}

